package com.unipi.talepis.protal2024_5;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;
import androidx.lifecycle.Observer;
import androidx.work.Data;
import androidx.work.OneTimeWorkRequest;
import androidx.work.WorkInfo;
import androidx.work.WorkManager;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_main);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });
    }
    public void go1(View view){
        Intent intent = new Intent(this,MyService.class);
        startService(intent);
        //stopService(intent);//don't use this method, no force stop
        //startForegroundService(intent);//to be implemented
    }
    public void stopTheService(){
        Intent intent = new Intent(this,MyService.class);
        intent.setAction("STOP_SERVICE");
        startService(intent);
    }
    public void go2(View view){
        TextView textView = findViewById(R.id.textView);
        textView.setText("");
        WorkManager manager = WorkManager.getInstance(this);
        Data toSend = new Data.Builder()
                .putString("key1","Unipi").build();
        OneTimeWorkRequest request = new OneTimeWorkRequest.Builder(MyWorker.class)
                .setInputData(toSend)
                .build();
        manager.enqueue(request);
        manager.getWorkInfoByIdLiveData(request.getId())
                .observe(this, workInfo -> {
                    if (workInfo!=null){
                        textView.append(workInfo.getState().toString()+"\n");
                        if (workInfo.getState()== WorkInfo.State.SUCCEEDED){
                            textView.append(workInfo.getOutputData().toString());
                        }
                    }
                });
    }
}